﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using DataAccessClass;
using Infragistics.Web.UI.NavigationControls;
using System.Text;
using TeamMSI;
using System.Web.UI.HtmlControls;

namespace Layout
{
    public partial class TeamMSI : System.Web.UI.MasterPage
    {

        private string userid;
        private string uname;
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
#if DEBUG
                lblUserName.Text = "sunu";
                //lblError.Text = "<br><font color='Red'><b>This web application is in debug mode - Please notify the IT team immediately</b></font><br>";
                if (lblUserName.Text != string.Empty)
                {
#else

                //if ((Request.Cookies["teammsiuid"].Value.Trim().ToLower() != "none" )&&(Request.Cookies["teammsiuid"] != null))
              // {
                    
                //  lblUserName.Text = Request.Cookies["teammsiuid"].Value.Trim();                
               if(lblUserName.Text != string.Empty)
               {
#endif
                    //ScriptManager1.RegisterAsyncPostBackControl(btnSignIn);
                    //string userID = Context.Request.Cookies["teammsiuid"].Value.Trim();

                    //Get Menu details with locks
                    BindMenuNodeAfterLogin();
                }
                else
                {
                    // Get menu details without lock
                    BindMenuNode();
                    SetFocus();

                }

                tbxCalendar.Text = DateTime.Now.ToShortDateString();
                if (base.Request.UserAgent.IndexOf("AppleWebKit") > 0)
                {
                   
                    base.Request.Browser.Adapters.Clear();
                    this.Page.ClientTarget = "uplevel";                   
                    //HtmlMeta metaTag = new HtmlMeta();
                    //metaTag.Name = "viewport";
                    //metaTag.Content = "width=device-width";
                    //Page.Header.Controls.Add(metaTag);
                   
                }
            }
            catch (Exception ex)
            {
                //lblmasterError.Text = ex.InnerException.Message;
            }
        }


        protected void BindMenuNode()
        {
            //Read the XML before login
            DataSet ds = new DataSet();
            ds.DataSetName = "TreeDataSet";
            //ds.ReadXml("//10.1.1.2/websites/IA/TeamMSI/XMLTeamMSIDataMenu.xml").ToString();
            //ds.ReadXml("//10.1.1.2/websites/IA/TeamMSI/XMLTeamMSIInsecureDataMenu.xml").ToString();
            ds.ReadXml("//10.1.1.2/websites/IA/TeamMSI/XMLTeamMSIDataMenu_TestAda.xml").ToString();
            this.webTeamMSIMenu.DataSource = ds;
            this.webTeamMSIMenu.DataBind();
        }
        protected void BindMenuNodeAfterLogin()
        {
            //Read the XML after login
            DataSet ds = new DataSet();
            ds.DataSetName = "TreeDataSet";
            //ds.ReadXml("//10.1.1.2/websites/IA/TeamMSI/XMLTeamMSIDataMenu.xml").ToString();
            ds.ReadXml("//10.1.1.2/websites/IA/TeamMSI/XMLTeamMSIDataMenu_TestAda.xml").ToString();
            //ds.ReadXml(HttpContext.Current.Server.MapPath("testxml.xml"));
            this.webTeamMSIMenu.DataSource = ds;
            this.webTeamMSIMenu.DataBind();
        }
        protected void SetFocus()
        {
            try
            {
                //Javascript to keep the focus on the login textbox
                pnlLogin.Visible = true;
                StringBuilder sb = new StringBuilder();
                sb.Append("<script type=\"text/javascript\">\n");
                sb.Append("Sys.Application.add_load(modalSetup);\n");
                sb.Append("function modalSetup() {\n");
                sb.Append(String.Format("var modalPopup = $find('{0}');\n", mdlPopLogin.BehaviorID));
                sb.Append("modalPopup.add_shown(SetFocusOnControl); }\n");
                sb.Append("function SetFocusOnControl() {\n");
                sb.Append(String.Format("var textBox1 = $get('{0}');\n", tbxLogin.ClientID));
                sb.Append("textBox1.focus();}\n");
                sb.Append("</script>\n");
                Page.ClientScript.RegisterStartupScript(Page.GetType(), "Startup", sb.ToString());

            }
            catch (Exception ex)
            {

                //throw;
            }


        }

        private void CreateAllCookies()
        {
            //set the themes
            string ThemeName = "";
            DataProvider dp = new DataProvider();
            dp.ConnectionString = ConfigurationManager.ConnectionStrings["conDeveloper_SQLWeb"].ConnectionString;
            //set the uname var to the username
            uname = tbxLogin.Text;
            string domain = "domain-msi";

            string adPath = ConfigurationSettings.AppSettings["LDAPConnString"]; //Path to your LDAP directory server //UPDATED by KUSH/KISHOR.
            //string adPath = "LDAP://cn=users,dc=domain-msi"; //Path to your LDAP directory server
            //Attempt to authorize
            LdapAuthentication adAuth = new LdapAuthentication(adPath);
            try
            {
                if (true == adAuth.IsAuthenticated(domain, tbxLogin.Text, tbxPassword.Text))
                {
                    string groups = adAuth.GetGroups();


                    //Create a cookie, and then add the encrypted ticket to the cookie as data.
                    HttpCookie authCookie = new HttpCookie("teammsiuid", tbxLogin.Text);
                    //authCookie.Values["ThemeName"] = "";
                    authCookie.Domain = "msistone.com";
                    authCookie.Expires = DateTime.Now.AddHours(12);
                    Response.Cookies.Add(authCookie);

                    if (tbxLogin.Text != string.Empty || tbxLogin.Text != "")
                    {
                        ThemeName = dp.GetScalerByParams("SELECT ThemeName FROM dbo.tTeamMSI_Themes WHERE UserName='" + tbxLogin.Text + "'");
                    }
                    if (ThemeName != string.Empty || ThemeName != "")
                    {
                        HttpCookie Themes = new HttpCookie("ThemeName", ThemeName);
                        Themes.Expires = DateTime.Now.AddHours(12);
                        Response.Cookies.Add(Themes);
                    }
                    else
                    {

                        HttpCookie Themes = new HttpCookie("ThemeName", Page.Theme);
                        Themes.Expires = DateTime.Now.AddHours(12);
                        Response.Cookies.Add(Themes);

                    }


                    //=============================================================================
                    string strTheHashKey = "";
                    using (CookieSecurityValues objCookieSecurityValues = new CookieSecurityValues(tbxLogin.Text))
                    {
                        strTheHashKey = objCookieSecurityValues.strGetEncryptedKey();
                    }
                    HttpCookie hckHashValues = new HttpCookie("hashkey", strTheHashKey);
                    //*****************************************************************************



                    hckHashValues.Domain = "msistone.com";
                    hckHashValues.Expires = DateTime.Now.AddHours(12);
                    Response.Cookies.Add(hckHashValues);
                    Response.Redirect("Default.aspx");
                }//End 
                else
                {
                    Do_Invalid();
                }//End if
            }
            catch (Exception ex)
            {
                lblAuthError.Text = ex.Message;
                Do_Invalid();



            }//End catch

        }

        //Destroy the cookies
        private void DestroyAllCookies()
        {
            //Reset the cookie to "none"
            Response.Cache.SetExpires(DateTime.UtcNow.AddMinutes(-1));
            Response.Cache.SetCacheability(HttpCacheability.NoCache);
            Response.Cache.SetNoStore();
            Session.Abandon();
            Session.Clear();
            Response.Cookies.Remove("ThemeName");
            if (Request.Cookies["ThemeName"] != null)
            {
                var c = new HttpCookie("ThemeName");
                c.Expires = DateTime.Now.AddDays(-1);
                Response.Cookies.Add(c);
            }
            if (Request.Cookies["teammsiuid"] != null)
            {
                var cookie = new HttpCookie("teammsiuid", "none");
                cookie.Domain = "msistone.com";
                Response.Cookies.Add(cookie);
            }
            HttpCookie hckHashCookie = new HttpCookie("hashkey", "none");
            hckHashCookie.Domain = "msistone.com";
            Response.Cookies.Add(hckHashCookie);
        }
        private void Do_Invalid()
        {
            //warn of invalid username or password
            lblAuthError.Visible = true;
            lblAuthError.Text = "<font color=red>Invalid Username/Password</font>";

            //Clear the textboxes
            //let them try again
            tbxLogin.Text = "";
            tbxPassword.Text = "";
            pnlLogin.Visible = true;
            mdlPopLogin.Show();
        }//End Do_Invalid()

        protected void Timer1_Tick(object sender, EventArgs e)
        {
            lblTimer.Text = DateTime.Now.ToLongTimeString() + "(PST)";
        }
        protected void btnLogin_Click(object sender, EventArgs e)
        {
            if (tbxLogin.Text != string.Empty && tbxPassword.Text != string.Empty)
            {
                CreateAllCookies();

            }
            else
            {
                pnlLogin.Visible = true;
                mdlPopLogin.Show();
            }

        }
        protected void btnLogout_Click(object sender, EventArgs e)
        {
            //ON Logging out set the panel position
            //  string favlocx, favlocy, taskx, tasky, announcex, announcey;
            //    HttpCookie Themes = (HttpCookie)(Request.Cookies["ThemesName"]);
            //  if (Themes != null)
            //  {
            //string username = Themes["UserID"];
            //favlocx = FavLocX.Value;
            //favlocy = FavLocY.Value;
            //taskx = TaskLocX.Value;
            //tasky = TaskLocY.Value;
            //announcex = AnnounceLocX.Value;
            //announcey = AnnounceLocY.Value;  
            //  DataProvider dp = new DataProvider();
            //  dp.ConnectionString = ConfigurationManager.ConnectionStrings["conDeveloper_SQLWeb"].ConnectionString;
            //  SqlParameter[] param = new SqlParameter[7];
            //  param[0] = new SqlParameter("@favpositionX",favlocx);
            //  param[1] = new SqlParameter("@favpostionY", favlocy);
            //  param[2] = new SqlParameter("@taskpositionX", taskx);
            //  param[3] = new SqlParameter("@taskpositionY", tasky);
            //  param[4] = new SqlParameter("@announcepositionX", announcex);
            //  param[5] = new SqlParameter("@announcepositionY", announcey);
            //  param[6] = new SqlParameter("@UserName", username);
            //  dp.InsertDeleteUpdateDataStrProc("uspNewMSIMaster_InsertPanelPosition", param);
            //      }            
            DestroyAllCookies();
            Response.Redirect("index.aspx");
        }
        protected void btnLoginClick(object sender, EventArgs e)
        {
            lblAuthError.Visible = false;
            pnlLogin.Enabled = true;
            SetFocus();


        }
        protected void btnSearch_Click(object sender, EventArgs e)
        {
            ScriptManager.RegisterStartupScript(Page, typeof(Page), "OpenWindow", "javascript:window.open('http://intranet.msistone.com/teammsimenusearch/TeamMSIMenuSearch.aspx?SearchKey=" + txtSearchTeamMSI.Text + "');", true);
            
            if (base.Request.UserAgent.IndexOf("AppleWebKit") > 0)
            {
               
                base.Request.Browser.Adapters.Clear();
                this.Page.ClientTarget = "uplevel";
                Response.Redirect("http://intranet.msistone.com/teammsimenusearch/TeamMSIMenuSearch.aspx?SearchKey=" +txtSearchTeamMSI.Text);
            }
            txtSearchTeamMSI.Text = "";
        }


    }
}
