﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using DataAccessClass;
using System.Configuration;
using System.Net;
using System.Web.UI.HtmlControls;
using System.Data;
using System.Data.SqlClient;
using AjaxControlToolkit;
using TeamMSI;

namespace TeamMSI
{
    public partial class _Default : Page
    {
        private string strCurrentCategory = "";
        string username;

        protected void Page_PreInit(object sender, EventArgs e)
        {
            try
            {
                DataProvider dp = new DataProvider();
                dp.ConnectionString = ConfigurationManager.ConnectionStrings["conDeveloper_SQLWeb"].ConnectionString;
                if (Request.Cookies["ThemeName"] != null)
                {
                    Page.Theme = Request.Cookies["ThemeName"].Value.Trim(); // Set ThemeName

                }
                else
                {
                    Page.Theme = "firsttheme"; // Default Theme
                }
                if (BrowserUpLevel.IsUplevel)
                {
                    Page.ClientTarget = "uplevel";
                }

            }
            catch (Exception ex)
            {
                lblError.Text = ex.Message;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                UpdatePanel udpnl = (UpdatePanel)Master.FindControl("upnlLogin");
                ModalPopupExtender mdlPopuP = (ModalPopupExtender)Master.FindControl("mdlPopLogin");
                HttpCookie authCookie = (HttpCookie)(Request.Cookies["teammsiuid"]);
                Label lblUserName = (Label)Master.FindControl("lblUserName");
                LinkButton btnLogin = (LinkButton)Master.FindControl("btnLogin");
                LinkButton btnLogOut = (LinkButton)Master.FindControl("lnkLogin");
                Panel pnlLogin = (Panel)Master.FindControl("pnlLogin");
                Label lblAuthError = (Label)udpnl.FindControl("lblAuthError");

#if DEBUG
                username = "sunu";
                //lblError1.Text = "<br><font color='Red'><b>This web application is in debug mode - Please notify the IT team immediately</b></font><br>";
                if (username != string.Empty)
                {
#else

                if (Request.Cookies["teammsiuid"] != null && Request.Cookies["teammsiuid"].Value.Trim().ToLower() != "none")
                {
                    username = Request.Cookies["teammsiuid"].Value.Trim();

#endif
                    if (base.Request.UserAgent.IndexOf("AppleWebKit") > 0)
                    {
                        //trSpace.Visible = true;
                        base.Request.Browser.Adapters.Clear();
                        this.Page.ClientTarget = "uplevel";
                        MovingContent.Attributes.Add("class", "scroller_containerSafari");
                        //HtmlMeta metaTag = new HtmlMeta();
                        //metaTag.Name = "viewport";
                        //metaTag.Content = "width=device-width";
                        //Header.Controls.Add(metaTag);
                        //ltrSpace.Text = "<table width='100%'><tr><td><br/></td></tr></table>";
                        //pnlHeaderAnnouncement.Attributes.Add("class", "hdSafari");
                        //pnlContainerTab.Attributes.Add("class", "bdSafari");
                        //tdAnnounce.Attributes.Add("class", "tdAnnounceClassSafari");
                    }


                    string ThemeName = string.Empty;
                    if (!IsPostBack)
                    {
                        DataProvider dp = new DataProvider();
                        dp.ConnectionString = ConfigurationManager.ConnectionStrings["conDeveloper_SQLWeb"].ConnectionString;
                        if (username != string.Empty)
                        {

                            btnLogin.Visible = false;
                            pnlLogin.Visible = false;
                            lblUserName.Visible = true;
                            btnLogOut.Visible = true;
                            lblAuthError.Visible = false;
                            //Getting themes if user have the saved theme
                            lblUserName.Text = "Welcome," + " " + "<font style='text-transform: uppercase;'>" + username + "</font>";
                            ThemeName = dp.GetScalerByParams("SELECT ThemeName FROM dbo.tTeamMSI_Themes WHERE UserName='" + username + "'");
                            if ((ThemeName != string.Empty || ThemeName != "") && (Request.Cookies["ThemeName"] != null))
                            {

                                //Set theme details in to the Cookiee
                                Request.Cookies["ThemeName"].Value = ThemeName;
                                Request.Cookies["ThemeName"].Expires = DateTime.Now.AddDays(1);
                                Response.Cookies.Add(Request.Cookies["ThemeName"]);
                            }
                            else if (Request.Cookies["ThemeName"] != null)
                            {
                                //Set theme details in to the Cookiee
                                Request.Cookies["ThemeName"].Value = Page.Theme;
                                Request.Cookies["ThemeName"].Expires = DateTime.Now.AddDays(1);
                                Response.Cookies.Add(Request.Cookies["ThemeName"]);
                            }


                            //Setting the position of the panel 

                            //SqlParameter[] param = new SqlParameter[1];
                            //param[0] = new SqlParameter("@UserName", username);

                            //DataSet dspnlPosition = new DataSet();
                            //dspnlPosition = dp.GetDataSetSProcWithProc("uspNewMSIMaster_GetPanelPosition", param);
                            //if (dspnlPosition.Tables[0].Rows.Count > 0)
                            //{
                            //    SetFavLocX.Value = dspnlPosition.Tables[0].Rows[0]["FavX"].ToString();
                            //    SetFavLocY.Value = dspnlPosition.Tables[0].Rows[0]["FavY"].ToString();
                            //    SetTaskLocX.Value = dspnlPosition.Tables[1].Rows[0]["taskX"].ToString();
                            //    SetTaskLocY.Value = dspnlPosition.Tables[1].Rows[0]["taskY"].ToString();
                            //    SetAnnounceLocX.Value = dspnlPosition.Tables[2].Rows[0]["announceX"].ToString();
                            //    SetAnnounceLocY.Value = dspnlPosition.Tables[2].Rows[0]["announceY"].ToString();
                            //}

                            //When user Logged in get the Announcement & Favorites for the particular user
                            pnlMyTask.Visible = true;
                            Get_Favorites(username);
                            Get_Announcements(username);
                            //this.Page.ClientScript.RegisterStartupScript(this.Page.GetType(), "loadSavedPosition", "setPosition();", true);                         
                        }
                        else
                        {
                            btnLogin.Visible = true;
                            pnlLogin.Visible = true;
                            lblUserName.Visible = false;
                            btnLogOut.Visible = false;

                        }
                    }
                }
                else
                {
                    Response.Redirect("index.aspx");
                    //when user not logged in Get the announcements common 
                   // pnlMyTask.Visible = false;
                    //if (!IsPostBack)
                    //{
                       // pnlLogin.Visible = true;
                       // mdlPopuP.Show(); // Login modal popup
                   // }
                    //Get_Announcements(string.Empty);

                }
            }

            catch (Exception ex)
            {

            }

        }

        override protected void OnInit(EventArgs e)
        {
            InitializeComponent();
            base.OnInit(e);
        }

        private void InitializeComponent()
        {
            this.dgFaves.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dgFaves_ItemDataBound);
        }
        private void Get_Favorites(string username)
        {
            DataProvider dp = new DataProvider();
            dp.ConnectionString = ConfigurationManager.ConnectionStrings["conSecurityPortal_SQLWeb"].ConnectionString;
            //Get details for the favorites
            DataSet ds = new DataSet();
            try
            {
                ds = dp.GetDataSetQuery("SELECT FaveCategory, FaveURL , FaveName FROM UserFavorites WHERE userid = '" + username + "' ORDER BY FaveCategory, FaveName");
                this.dgFaves.DataSource = ds.Tables[0];
                this.dgFaves.DataBind();
                if (ds.Tables[0].Rows.Count > 0)
                {
                    pnlFavorites.Visible = true;
                }


            }
            catch (Exception Ex)
            {
                lblError.Text = "Exception Error (Favorite Links): " + Ex.Message; ;

            }
            finally
            {
                ds.Dispose();

            }
        }

        //Announcement for all employees
        private void Get_Announcements(string username)
        {
            DataTable dtAnnouncementAllEmployees = new DataTable();
            DataProvider dp = new DataProvider();
            dp.ConnectionString = ConfigurationManager.ConnectionStrings["conMSI_SQLWeb"].ConnectionString;
            dtAnnouncementAllEmployees = (dp.GetDataSetSProc("uspNewMSIAnnouncements_GetAnnouncements_AllEmployees")).Tables[0];


            //if the user is not logged in
            if (username == string.Empty)
            {
                try
                {
                    if (dtAnnouncementAllEmployees.DefaultView.Count > 0)
                    {
                        this.lblAnnounce.Visible = false;
                        this.dgAnnounce.DataSource = dtAnnouncementAllEmployees;
                        this.dgAnnounce.DataBind();
                        this.lbltmMsiCount.Text = dtAnnouncementAllEmployees.Rows.Count.ToString();
                        this.pnlTeamMSITab.Visible = true;
                        string s1 = "";

                        for (int i = 0; i < dtAnnouncementAllEmployees.Rows.Count; i++)
                        {
                            s1 += dtAnnouncementAllEmployees.Rows[i][0].ToString() + "&nbsp;&nbsp;";
                        }
                        lblAnnouncescroll.Text = s1.TrimEnd().ToString();
                        this.lblmyteamCount.Text = "0";
                        this.lblSupervisorCount.Text = "0";
                    }
                    else
                    {
                        this.lblAnnounce.Visible = true;
                        this.lblAnnounce.Text = "<b>No Announcements for Team MSI</b>";
                        this.dgAnnounce.DataSource = null;
                        this.dgAnnounce.DataBind();
                        this.pnlTeamMSITab.Visible = false;
                        this.lbltmMsiCount.Text = "0";
                    }

                }
                catch (Exception Ex)
                {
                    lblError.Text = "<font color='Red'><b>Exception - Get_Announcements(): " + Ex.Message + "</b></font><br>";
                }
                finally
                {

                    dtAnnouncementAllEmployees.Dispose();
                }
            }
            else //If the user is logged in
            {
                //Announcement for all employees
                string s1 = "";
                try
                {
                    if (dtAnnouncementAllEmployees.DefaultView.Count > 0)
                    {
                        this.lblAnnounce.Visible = false;
                        this.dgAnnounce.DataSource = dtAnnouncementAllEmployees;
                        this.dgAnnounce.DataBind();
                        this.lbltmMsiCount.Text = dtAnnouncementAllEmployees.Rows.Count.ToString();
                        this.pnlTeamMSITab.Visible = true;


                        for (int i = 0; i < dtAnnouncementAllEmployees.Rows.Count; i++)
                        {
                            s1 += dtAnnouncementAllEmployees.Rows[i][0].ToString() + "&nbsp;&nbsp;";
                        }
                        lblAnnouncescroll.Text = s1.TrimEnd().ToString();
                    }
                    else
                    {
                        this.lblAnnounce.Visible = true;
                        this.lblAnnounce.Text = "<b>No Announcements for Team MSI</b>";
                        this.dgAnnounce.DataSource = null;
                        this.dgAnnounce.DataBind();
                        this.pnlTeamMSITab.Visible = false;
                        this.lbltmMsiCount.Text = "0";
                    }

                }
                catch (Exception Ex)
                {
                    lblError.Text = "<font color='Red'><b>Exception - Get_Announcements(): " + Ex.Message + "</b></font><br>";
                }
                finally
                {

                    dtAnnouncementAllEmployees.Dispose();
                }
                try
                {
                    //Announcement for team and supervisors
                    string strSupervisorStatus = "";
                    DataSet ds = new DataSet();
                    SqlParameter[] param = new SqlParameter[2];
                    param[0] = new SqlParameter("@nvarLoginUser", SqlDbType.NVarChar, 100);
                    param[0].Direction = ParameterDirection.Input;
                    param[0].Value = username.Trim();
                    param[1] = new SqlParameter("@nvarSupervisorStatus", SqlDbType.NVarChar, 100);
                    param[1].Direction = ParameterDirection.Output;
                    param[1].Value = "";
                    ds = dp.GetDataSetSProcWithProc("uspNewMSIAnnouncements_GetAnnouncements_TeamsAndSupervisors", param);
                    strSupervisorStatus = param[1].Value.ToString();


                    if (ds.Tables[0].DefaultView.Count > 0)
                    {
                        lblAnnouncementsTeams.Visible = false;
                        dgAnnouncementTeams.DataSource = ds.Tables[0];
                        dgAnnouncementTeams.DataBind();
                        dgAnnouncementTeams.Visible = true;
                        this.pnlMyTeamTab.Visible = true;
                        lblmyteamCount.Text = ds.Tables[0].Rows.Count.ToString();
                        s1 += "<b>Announcement for Your Team and You:</b>&nbsp;&nbsp;";
                        for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                        {
                            s1 += ds.Tables[0].Rows[i]["Announcements"].ToString() + "&nbsp;&nbsp;";
                        }
                        lblAnnouncescroll.Text = s1.TrimEnd().ToString();
                    }
                    else
                    {
                        lblAnnouncementsTeams.Visible = true;
                        lblAnnouncementsTeams.Text = "No announcements for You";
                        dgAnnouncementTeams.DataSource = null;
                        dgAnnouncementTeams.DataBind();
                        this.pnlMyTeamTab.Visible = false;
                        lblmyteamCount.Text = "0";
                    }

                    if (strSupervisorStatus == "supervisor")
                    {
                        if (ds.Tables[1].DefaultView.Count > 0)
                        {
                            lblAnnouncementsSupervisor.Visible = false;
                            lblAnnouncementsSupervisor.Text = "<b>Announcements for Supervisors</b>";
                            dgAnnouncementSupervisors.DataSource = ds.Tables[1];
                            dgAnnouncementSupervisors.DataBind();
                            dgAnnouncementSupervisors.Visible = true;
                            pnlSupervisorTab.Visible = true;
                            lblSupervisorCount.Text = ds.Tables[1].Rows.Count.ToString();
                            s1 += "<b>Announcement for Supervisors:</b>&nbsp;&nbsp;";
                            for (int i = 0; i < ds.Tables[1].Rows.Count; i++)
                            {
                                s1 += ds.Tables[1].Rows[i]["Announcements"].ToString() + "&nbsp;&nbsp;";
                            }
                            lblAnnouncescroll.Text = s1.TrimEnd().ToString();
                        }
                        else
                        {
                            lblAnnouncementsSupervisor.Visible = true;
                            lblAnnouncementsSupervisor.Text = "<b>No announcements for Supervisors</b>";
                            dgAnnouncementSupervisors.DataSource = null;
                            dgAnnouncementSupervisors.DataBind();
                            pnlSupervisorTab.Visible = false;
                            lblSupervisorCount.Text = "0";
                        }

                    }
                    else
                    {
                        lblAnnouncementsSupervisor.Visible = true;
                        lblAnnouncementsSupervisor.Text = "<b>No announcements for Supervisors</b>";
                        dgAnnouncementSupervisors.DataSource = null;
                        dgAnnouncementSupervisors.DataBind();
                        pnlSupervisorTab.Visible = false;
                        lblSupervisorCount.Text = "0";
                    }


                }
                catch (Exception Ex)
                {
                    lblError.Text = "Exception Error: Get_AnnouncementsTeamsAndSupervisors(): " + Ex.Message;
                }
                dgAnnouncementTeams.SelectedIndex = -1;
                dgAnnouncementSupervisors.SelectedIndex = -1;


            }



        }

        private void dgFaves_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
        {
            //create a string by which the categories can be checked
            string strCategory = e.Item.Cells[0].Text.Trim();
            //if the string is equal to the stored original category
            if (strCategory.Trim() == strCurrentCategory.Trim())
            {
                //the current cell[0] equals blank
                e.Item.Cells[0].Text = "";
            }//End if
            else
            {
                //the current string equals the new category
                strCurrentCategory = strCategory;
            }//End else
        }
    }
}